import { system, world } from "@minecraft/server";
import { ActorComponent, clamp, getAllPlayersSafe, mclog, readDynamicProperty, SafetyCheckedEntity, SafetyCheckedPlayer, waitForTicks, writeDynamicProperty } from "../utils/index";
import { BruceLee } from "./bruce_lee";
import { incrementAchievement } from "../achievements";
export class BruceLeeProperties extends ActorComponent {
    constructor(actor) {
        super(actor, undefined);
        this.onKillBinding = this.onKill.bind(this);
    }
    get Alive() {
        var _a;
        return ((_a = this.actor) === null || _a === void 0 ? void 0 : _a.getProperty("ldz_240913:health")) > 0;
    }
    get Experience() {
        var _a;
        return (_a = this.actor) === null || _a === void 0 ? void 0 : _a.getProperty("ldz_240913:experience");
    }
    set Experience(value) {
        var _a, _b;
        (_a = this.actor) === null || _a === void 0 ? void 0 : _a.setProperty("ldz_240913:experience", value);
        (_b = this.actor) === null || _b === void 0 ? void 0 : _b.raiseEvent("save");
    }
    get ExperienceToNextLevel() {
        var _a;
        return (_a = this.actor) === null || _a === void 0 ? void 0 : _a.getProperty("ldz_240913:experience_to_next_level");
    }
    set ExperienceToNextLevel(value) {
        var _a, _b;
        (_a = this.actor) === null || _a === void 0 ? void 0 : _a.setProperty("ldz_240913:experience_to_next_level", value);
        (_b = this.actor) === null || _b === void 0 ? void 0 : _b.raiseEvent("save");
    }
    get Level() {
        var _a;
        return (_a = this.actor) === null || _a === void 0 ? void 0 : _a.getProperty("ldz_240913:level");
    }
    set Level(value) {
        var _a, _b;
        if (value > 40)
            return;
        if (this.MartialArt === "none" && value > 10)
            return;
        (_a = this.actor) === null || _a === void 0 ? void 0 : _a.setProperty("ldz_240913:level", value);
        this.HighestLevelBruceLee = value;
        (_b = this.actor) === null || _b === void 0 ? void 0 : _b.raiseEvent("save");
    }
    get SkillPoints() {
        var _a, _b;
        return (_b = (_a = this.actor) === null || _a === void 0 ? void 0 : _a.getDynamicProperty("ldz_240913:skill_points")) !== null && _b !== void 0 ? _b : 0;
    }
    set SkillPoints(value) {
        var _a, _b;
        (_a = this.actor) === null || _a === void 0 ? void 0 : _a.setDynamicProperty("ldz_240913:skill_points", value);
        (_b = this.actor) === null || _b === void 0 ? void 0 : _b.raiseEvent("save");
    }
    get Health() {
        var _a;
        return (_a = this.actor) === null || _a === void 0 ? void 0 : _a.getProperty("ldz_240913:health");
    }
    set Health(value) {
        var _a, _b;
        value = clamp(value, 0, this.MaxHealth);
        (_a = this.actor) === null || _a === void 0 ? void 0 : _a.setProperty("ldz_240913:health", value);
        if (value < this.MaxHealth * 0.5 && this.HealthFlash === "enabled") {
            this.HealthFlash = "flashing";
        }
        else if (value >= this.MaxHealth * 0.5 && this.HealthFlash === "flashing") {
            this.HealthFlash = "enabled";
        }
        if (value < this.MaxHealth * 0.5 && this.Mood < 5) {
            this.Mood = 5;
        }
        else if (value >= this.MaxHealth * 0.5 && this.Mood === 5) {
            this.Mood = this.PreviousMood;
        }
        if (value < this.MaxHealth * 0.2 && this.Mood < 6) {
            this.Mood = 6;
        }
        else if (value >= this.MaxHealth * 0.2 && this.Mood === 6) {
            this.Mood = this.PreviousMood;
        }
        if (this.Meditating) {
            this.Mood = 8;
        }
        if (value < this.MaxHealth * 0.5 && this.Outfit <= 10) {
            this.Outfit = this.Outfit + 11;
        }
        else if (value >= this.MaxHealth * 0.5 && this.Outfit > 10 && this.Outfit <= 21) {
            this.Outfit = this.Outfit - 11;
        }
        if (value < this.MaxHealth * 0.2 && this.Outfit <= 21) {
            this.Outfit = this.Outfit + 11;
        }
        else if (value >= this.MaxHealth * 0.5 && this.Outfit > 21) {
            this.Outfit = this.Outfit - 22;
        }
        else if (value >= this.MaxHealth * 0.2 && this.Outfit > 21) {
            this.Outfit = this.Outfit - 11;
        }
        (_b = this.actor) === null || _b === void 0 ? void 0 : _b.raiseEvent("save");
    }
    get MaxHealth() {
        var _a;
        return (_a = this.actor) === null || _a === void 0 ? void 0 : _a.getProperty("ldz_240913:max_health");
    }
    set MaxHealth(value) {
        var _a, _b;
        (_a = this.actor) === null || _a === void 0 ? void 0 : _a.setProperty("ldz_240913:max_health", value);
        (_b = this.actor) === null || _b === void 0 ? void 0 : _b.raiseEvent("save");
    }
    get MartialArt() {
        var _a;
        return (_a = this.actor) === null || _a === void 0 ? void 0 : _a.getProperty("ldz_240913:martial_art");
    }
    set MartialArt(value) {
        var _a, _b;
        (_a = this.actor) === null || _a === void 0 ? void 0 : _a.setProperty("ldz_240913:martial_art", value);
        (_b = this.actor) === null || _b === void 0 ? void 0 : _b.raiseEvent("save");
    }
    get BlockChance() {
        var _a;
        return (_a = this.actor) === null || _a === void 0 ? void 0 : _a.getProperty("ldz_240913:block_chance");
    }
    set BlockChance(value) {
        var _a, _b;
        (_a = this.actor) === null || _a === void 0 ? void 0 : _a.setProperty("ldz_240913:block_chance", value);
        (_b = this.actor) === null || _b === void 0 ? void 0 : _b.raiseEvent("save");
    }
    get DragonFuryCharge() {
        var _a;
        return (_a = this.actor) === null || _a === void 0 ? void 0 : _a.getProperty("ldz_240913:dragon_fury_charge");
    }
    set DragonFuryCharge(value) {
        var _a, _b, _c;
        (_a = this.actor) === null || _a === void 0 ? void 0 : _a.setProperty("ldz_240913:dragon_fury_charge", value);
        (_b = this.actor) === null || _b === void 0 ? void 0 : _b.raiseEvent("save");
        if (value >= 100) {
            (_c = this.actor.SoundPlayer) === null || _c === void 0 ? void 0 : _c.playSound("dragon_fury_charged");
        }
    }
    get DragonFuryLevel() {
        var _a;
        return (_a = this.actor) === null || _a === void 0 ? void 0 : _a.getProperty("ldz_240913:dragon_fury_level");
    }
    set DragonFuryLevel(value) {
        var _a, _b;
        (_a = this.actor) === null || _a === void 0 ? void 0 : _a.setProperty("ldz_240913:dragon_fury_level", value);
        (_b = this.actor) === null || _b === void 0 ? void 0 : _b.raiseEvent("save");
    }
    get PerformingDragonFury() {
        var _a, _b;
        return (_b = (_a = this.actor) === null || _a === void 0 ? void 0 : _a.getProperty("ldz_240913:performing_dragon_fury")) !== null && _b !== void 0 ? _b : false;
    }
    set PerformingDragonFury(value) {
        var _a, _b;
        (_a = this.actor) === null || _a === void 0 ? void 0 : _a.setProperty("ldz_240913:performing_dragon_fury", value);
        (_b = this.actor) === null || _b === void 0 ? void 0 : _b.raiseEvent("save");
    }
    get FightingPriority() {
        var _a;
        return (_a = this.actor) === null || _a === void 0 ? void 0 : _a.getProperty("ldz_240913:fighting_priority");
    }
    set FightingPriority(value) {
        var _a, _b;
        (_a = this.actor) === null || _a === void 0 ? void 0 : _a.triggerEvent(`set_fighting_priority_to_${value}`);
        (_b = this.actor) === null || _b === void 0 ? void 0 : _b.raiseEvent("save");
    }
    get Mood() {
        var _a, _b;
        return (_b = (_a = this.actor) === null || _a === void 0 ? void 0 : _a.getProperty("ldz_240913:mood")) !== null && _b !== void 0 ? _b : 0;
    }
    set Mood(value) {
        var _a, _b;
        if (value < 0 || value > 8)
            return;
        if (value > 4 && this.Mood < 5) {
            this.PreviousMood = this.Mood;
        }
        (_a = this.actor) === null || _a === void 0 ? void 0 : _a.setProperty("ldz_240913:mood", value);
        (_b = this.actor) === null || _b === void 0 ? void 0 : _b.raiseEvent("save");
    }
    get Outfit() {
        var _a, _b;
        return (_b = (_a = this.actor) === null || _a === void 0 ? void 0 : _a.getProperty("ldz_240913:outfit")) !== null && _b !== void 0 ? _b : 0;
    }
    set Outfit(value) {
        var _a;
        (_a = this.actor) === null || _a === void 0 ? void 0 : _a.setProperty("ldz_240913:outfit", value);
        waitForTicks(5).then(() => {
            var _a;
            (_a = this.actor) === null || _a === void 0 ? void 0 : _a.raiseEvent("save");
        });
    }
    get Hairstyle() {
        var _a;
        return (_a = this.actor) === null || _a === void 0 ? void 0 : _a.getProperty("ldz_240913:hairstyle");
    }
    set Hairstyle(value) {
        var _a, _b;
        (_a = this.actor) === null || _a === void 0 ? void 0 : _a.setProperty("ldz_240913:hairstyle", value);
        (_b = this.actor) === null || _b === void 0 ? void 0 : _b.raiseEvent("save");
    }
    get Meditating() {
        var _a;
        return (_a = this.actor) === null || _a === void 0 ? void 0 : _a.getProperty("ldz_240913:meditating");
    }
    set Meditating(value) {
        var _a, _b;
        if (value) {
            this.Mood = 8;
            (_a = this.actor.SoundPlayer) === null || _a === void 0 ? void 0 : _a.playSound("meditate");
        }
        else if (value !== this.Meditating) {
            this.Mood = this.PreviousMood;
        }
        if (this.Meditating && !value) {
            this.CanAttack = true;
        }
        this.actor.triggerEvent(`set_meditating_to_${value}`);
        (_b = this.actor) === null || _b === void 0 ? void 0 : _b.raiseEvent("save");
    }
    get BlockedDamage() {
        var _a;
        return (_a = this.actor) === null || _a === void 0 ? void 0 : _a.getProperty("ldz_240913:blocked_damage");
    }
    set BlockedDamage(value) {
        var _a, _b;
        (_a = this.actor) === null || _a === void 0 ? void 0 : _a.setProperty("ldz_240913:blocked_damage", value);
        (_b = this.actor) === null || _b === void 0 ? void 0 : _b.raiseEvent("save");
    }
    get HealthFlash() {
        var _a, _b;
        return (_b = (_a = this.actor) === null || _a === void 0 ? void 0 : _a.getProperty("ldz_240913:health_flash")) !== null && _b !== void 0 ? _b : "enabled";
    }
    set HealthFlash(value) {
        var _a, _b;
        (_a = this.actor) === null || _a === void 0 ? void 0 : _a.setProperty("ldz_240913:health_flash", value);
        (_b = this.actor) === null || _b === void 0 ? void 0 : _b.raiseEvent("save");
    }
    get CanAttack() {
        var _a, _b;
        return (_b = (_a = this.actor) === null || _a === void 0 ? void 0 : _a.getDynamicProperty("ldz_240913:can_attack")) !== null && _b !== void 0 ? _b : true;
    }
    set CanAttack(value) {
        var _a, _b;
        mclog(`Setting can attack to ${value}`);
        (_a = this.actor) === null || _a === void 0 ? void 0 : _a.setDynamicProperty("ldz_240913:can_attack", value);
        (_b = this.actor) === null || _b === void 0 ? void 0 : _b.raiseEvent("save");
    }
    get OwnerId() {
        return this.actor.getDynamicProperty("ldz_240913:owner");
    }
    set OwnerId(value) {
        this.actor.setDynamicProperty("ldz_240913:owner", value);
        const player = getAllPlayersSafe().find(player => player.id === value);
        if (player) {
            this.actor.tame(player);
        }
    }
    get AttackDamage() {
        var _a, _b;
        return (_b = (_a = this.actor) === null || _a === void 0 ? void 0 : _a.getDynamicProperty("ldz_240913:attack_damage")) !== null && _b !== void 0 ? _b : 1;
    }
    set AttackDamage(value) {
        var _a, _b;
        (_a = this.actor) === null || _a === void 0 ? void 0 : _a.setDynamicProperty("ldz_240913:attack_damage", value);
        (_b = this.actor) === null || _b === void 0 ? void 0 : _b.raiseEvent("save");
    }
    get Speed() {
        var _a, _b;
        return (_b = (_a = this.actor) === null || _a === void 0 ? void 0 : _a.getDynamicProperty("ldz_240913:speed")) !== null && _b !== void 0 ? _b : 1;
    }
    set Speed(value) {
        var _a, _b;
        this.actor.triggerEvent(`add_speed_${value}`);
        (_a = this.actor) === null || _a === void 0 ? void 0 : _a.setDynamicProperty("ldz_240913:speed", value);
        (_b = this.actor) === null || _b === void 0 ? void 0 : _b.raiseEvent("save");
    }
    get DamageTaken() {
        var _a, _b;
        return (_b = (_a = this.actor) === null || _a === void 0 ? void 0 : _a.getDynamicProperty("ldz_240913:damage_taken")) !== null && _b !== void 0 ? _b : 0;
    }
    set DamageTaken(value) {
        var _a, _b;
        (_a = this.actor) === null || _a === void 0 ? void 0 : _a.setDynamicProperty("ldz_240913:damage_taken", value);
        (_b = this.actor) === null || _b === void 0 ? void 0 : _b.raiseEvent("save");
    }
    get DamageDealt() {
        var _a, _b;
        return (_b = (_a = this.actor) === null || _a === void 0 ? void 0 : _a.getDynamicProperty("ldz_240913:damage_dealt")) !== null && _b !== void 0 ? _b : 0;
    }
    set DamageDealt(value) {
        var _a, _b;
        (_a = this.actor) === null || _a === void 0 ? void 0 : _a.setDynamicProperty("ldz_240913:damage_dealt", value);
        (_b = this.actor) === null || _b === void 0 ? void 0 : _b.raiseEvent("save");
    }
    get AttacksBlocked() {
        var _a, _b;
        return (_b = (_a = this.actor) === null || _a === void 0 ? void 0 : _a.getDynamicProperty("ldz_240913:attacks_blocked")) !== null && _b !== void 0 ? _b : 0;
    }
    set AttacksBlocked(value) {
        var _a, _b, _c;
        const previousValue = (_a = this.actor.getDynamicProperty("ldz_240913:attacks_blocked")) !== null && _a !== void 0 ? _a : 0;
        (_b = this.actor) === null || _b === void 0 ? void 0 : _b.setDynamicProperty("ldz_240913:attacks_blocked", value);
        if (value > previousValue) {
            const difference = value - previousValue;
            if (this.actor.Owner) {
                incrementAchievement(this.actor.Owner, "block_attacks", difference);
            }
        }
        (_c = this.actor) === null || _c === void 0 ? void 0 : _c.raiseEvent("save");
    }
    get TimesKnockedOut() {
        var _a, _b;
        return (_b = (_a = this.actor) === null || _a === void 0 ? void 0 : _a.getDynamicProperty("ldz_240913:times_knocked_out")) !== null && _b !== void 0 ? _b : 0;
    }
    set TimesKnockedOut(value) {
        var _a, _b;
        (_a = this.actor) === null || _a === void 0 ? void 0 : _a.setDynamicProperty("ldz_240913:times_knocked_out", value);
        (_b = this.actor) === null || _b === void 0 ? void 0 : _b.raiseEvent("save");
    }
    get TimeAlive() {
        var _a, _b;
        return (_b = (_a = this.actor) === null || _a === void 0 ? void 0 : _a.getDynamicProperty("ldz_240913:time_alive")) !== null && _b !== void 0 ? _b : 0;
    }
    set TimeAlive(value) {
        var _a, _b;
        (_a = this.actor) === null || _a === void 0 ? void 0 : _a.setDynamicProperty("ldz_240913:time_alive", value);
        (_b = this.actor) === null || _b === void 0 ? void 0 : _b.raiseEvent("save");
    }
    get TimeMeditating() {
        var _a, _b;
        return (_b = (_a = this.actor) === null || _a === void 0 ? void 0 : _a.getDynamicProperty("ldz_240913:time_meditating")) !== null && _b !== void 0 ? _b : 0;
    }
    set TimeMeditating(value) {
        var _a, _b;
        (_a = this.actor) === null || _a === void 0 ? void 0 : _a.setDynamicProperty("ldz_240913:time_meditating", value);
        (_b = this.actor) === null || _b === void 0 ? void 0 : _b.raiseEvent("save");
    }
    get MobsDefeated() {
        var _a, _b;
        return (_b = (_a = this.actor) === null || _a === void 0 ? void 0 : _a.getDynamicProperty("ldz_240913:mobs_defeated")) !== null && _b !== void 0 ? _b : 0;
    }
    set MobsDefeated(value) {
        var _a, _b;
        (_a = this.actor) === null || _a === void 0 ? void 0 : _a.setDynamicProperty("ldz_240913:mobs_defeated", value);
        (_b = this.actor) === null || _b === void 0 ? void 0 : _b.raiseEvent("save");
    }
    get OpponentsDefeated() {
        var _a, _b;
        return (_b = (_a = this.actor) === null || _a === void 0 ? void 0 : _a.getDynamicProperty("ldz_240913:opponents_defeated")) !== null && _b !== void 0 ? _b : 0;
    }
    set OpponentsDefeated(value) {
        var _a, _b, _c;
        const previousValue = (_a = this.actor.getDynamicProperty("ldz_240913:opponents_defeated")) !== null && _a !== void 0 ? _a : 0;
        // mclog(`Set opponents defeated to ${value}`);
        (_b = this.actor) === null || _b === void 0 ? void 0 : _b.setDynamicProperty("ldz_240913:opponents_defeated", value);
        if (value > previousValue) {
            const difference = value - previousValue;
            if (this.actor.Owner) {
                incrementAchievement(this.actor.Owner, "defeat_opponents", difference);
            }
        }
        (_c = this.actor) === null || _c === void 0 ? void 0 : _c.raiseEvent("save");
    }
    get PreviousMood() {
        var _a, _b;
        return (_b = (_a = this.actor) === null || _a === void 0 ? void 0 : _a.getDynamicProperty("ldz_240913:previous_mood")) !== null && _b !== void 0 ? _b : 0;
    }
    set PreviousMood(value) {
        var _a, _b;
        (_a = this.actor) === null || _a === void 0 ? void 0 : _a.setDynamicProperty("ldz_240913:previous_mood", value);
        (_b = this.actor) === null || _b === void 0 ? void 0 : _b.raiseEvent("save");
    }
    set CanChargeDragonFury(value) {
        var _a, _b;
        (_a = this.actor) === null || _a === void 0 ? void 0 : _a.setDynamicProperty("ldz_240913:can_charge_dragon_fury", value);
        (_b = this.actor) === null || _b === void 0 ? void 0 : _b.raiseEvent("save");
    }
    get CanChargeDragonFury() {
        var _a, _b;
        return (_b = (_a = this.actor) === null || _a === void 0 ? void 0 : _a.getDynamicProperty("ldz_240913:can_charge_dragon_fury")) !== null && _b !== void 0 ? _b : false;
    }
    set HighestLevelBruceLee(value) {
        let highestLevel = this.HighestLevelBruceLee;
        if (value > highestLevel) {
            writeDynamicProperty(world, "ldz_240913:highest_level_bruce_lee", value);
        }
    }
    get HighestLevelBruceLee() {
        var _a;
        return (_a = readDynamicProperty(world, "ldz_240913:highest_level_bruce_lee")) !== null && _a !== void 0 ? _a : 0;
    }
    set Retired(value) {
        var _a, _b;
        (_a = this.actor) === null || _a === void 0 ? void 0 : _a.setDynamicProperty("ldz_240913:retired", value);
        (_b = this.actor) === null || _b === void 0 ? void 0 : _b.raiseEvent("save");
    }
    get Retired() {
        var _a, _b;
        return (_b = (_a = this.actor) === null || _a === void 0 ? void 0 : _a.getDynamicProperty("ldz_240913:retired")) !== null && _b !== void 0 ? _b : false;
    }
    onComponentAdded() {
        world.afterEvents.entityHitEntity.subscribe(this.onKillBinding, { entities: [this.actor.UnsafeEntity] });
    }
    onComponentRemoved() {
        world.afterEvents.entityHitEntity.unsubscribe(this.onKillBinding);
    }
    get StopFollowing() {
        var _a, _b;
        return (_b = (_a = this.actor) === null || _a === void 0 ? void 0 : _a.getDynamicProperty("ldz_240913:stop_following_player")) !== null && _b !== void 0 ? _b : false;
    }
    set StopFollowing(value) {
        var _a;
        (_a = this.actor) === null || _a === void 0 ? void 0 : _a.setDynamicProperty("ldz_240913:stop_following_player", value);
    }
    onKill(event) {
        var _a, _b;
        const hitEntity = new SafetyCheckedEntity(event.hitEntity);
        if (hitEntity && ((_b = (_a = hitEntity.Health) === null || _a === void 0 ? void 0 : _a.currentValue) !== null && _b !== void 0 ? _b : 0) <= 0) {
            if (hitEntity.typeId === "ldz_240913:opponent") {
                this.OpponentsDefeated++;
                if (this.actor.Owner) {
                    mclog("Increment defeat_50_opponents_consecutively achievement");
                    incrementAchievement(new SafetyCheckedPlayer(this.actor.Owner), "defeat_50_opponents_consecutively");
                }
            }
            else {
                this.MobsDefeated++;
            }
        }
    }
    getProperty(key) {
        return this[key];
    }
    setProperty(key, value) {
        if (this[key] !== undefined && typeof this[key] === typeof value) {
            this[key] = value;
        }
        else if (typeof this[key] === "number" && typeof value === "string") {
            this[key] = parseInt(value);
        }
    }
    getProperties() {
        return {
            Experience: this.Experience,
            Level: this.Level,
            Health: this.Health,
            MartialArt: this.MartialArt,
            BlockChance: this.BlockChance,
            DragonFuryCharge: this.DragonFuryCharge,
            DragonFuryLevel: this.DragonFuryLevel,
            PerformingDragonFury: this.PerformingDragonFury,
            FightingPriority: this.FightingPriority,
            Mood: this.Mood,
            Outfit: this.Outfit,
            Hairstyle: this.Hairstyle,
            Meditating: this.Meditating,
            BlockedDamage: this.BlockedDamage,
            AttackDamage: this.AttackDamage,
            Speed: this.Speed,
            DamageTaken: this.DamageTaken,
            DamageDealt: this.DamageDealt,
            AttacksBlocked: this.AttacksBlocked,
            TimesKnockedOut: this.TimesKnockedOut,
            TimeAlive: this.TimeAlive,
            TimeMeditating: this.TimeMeditating,
            MobsDefeated: this.MobsDefeated,
            OpponentsDefeated: this.OpponentsDefeated,
            SkillPoints: this.SkillPoints,
            MaxHealth: this.MaxHealth,
            OwnerId: this.OwnerId,
            CanAttack: this.CanAttack,
            HealthFlash: this.HealthFlash,
            ExperienceToNextLevel: this.ExperienceToNextLevel,
            PreviousMood: this.PreviousMood,
            CanChargeDragonFury: this.CanChargeDragonFury,
            HighestLevelBruceLee: this.HighestLevelBruceLee,
            Retired: this.Retired,
            StopFollowing: this.StopFollowing
        };
    }
    setProperties(properties) {
        this.Experience = properties.Experience;
        this.Level = properties.Level;
        this.Health = properties.Health;
        this.MartialArt = properties.MartialArt;
        this.BlockChance = properties.BlockChance;
        this.DragonFuryCharge = properties.DragonFuryCharge;
        this.DragonFuryLevel = properties.DragonFuryLevel;
        this.PerformingDragonFury = properties.PerformingDragonFury;
        this.FightingPriority = properties.FightingPriority;
        this.Mood = properties.Mood;
        this.Outfit = properties.Outfit;
        this.Hairstyle = properties.Hairstyle;
        this.Meditating = properties.Meditating;
        this.BlockedDamage = properties.BlockedDamage;
        this.AttackDamage = properties.AttackDamage;
        this.Speed = properties.Speed;
        this.DamageTaken = properties.DamageTaken;
        this.DamageDealt = properties.DamageDealt;
        this.AttacksBlocked = properties.AttacksBlocked;
        this.TimesKnockedOut = properties.TimesKnockedOut;
        this.TimeAlive = properties.TimeAlive;
        this.TimeMeditating = properties.TimeMeditating;
        this.MobsDefeated = properties.MobsDefeated;
        this.OpponentsDefeated = properties.OpponentsDefeated;
        this.SkillPoints = properties.SkillPoints;
        this.MaxHealth = properties.MaxHealth;
        this.OwnerId = properties.OwnerId;
        this.CanAttack = properties.CanAttack;
        this.HealthFlash = properties.HealthFlash;
        this.ExperienceToNextLevel = properties.ExperienceToNextLevel;
        this.PreviousMood = properties.PreviousMood,
            this.CanChargeDragonFury = properties.CanChargeDragonFury,
            this.HighestLevelBruceLee = properties.HighestLevelBruceLee,
            this.Retired = properties.Retired,
            this.StopFollowing = properties.StopFollowing;
    }
}
system.afterEvents.scriptEventReceive.subscribe((event) => {
    if (event.id === "ldz_240913:set_bruce_lee_properties" && event.message && event.sourceEntity) {
        try {
            const properties = JSON.parse(event.message);
            const bruceLee = BruceLee.getActor(event.sourceEntity.id, BruceLee);
            if (bruceLee) {
                bruceLee.Properties.setProperties(properties);
            }
        }
        catch (error) {
            mclog(`Error setting Bruce Lee properties: ${error}`);
        }
    }
    else if (event.id === "ldz_240913:set_bruce_lee_property" && event.message && event.sourceEntity) {
        try {
            const key = event.message.split(":")[0];
            const value = event.message.split(":")[1];
            const bruceLee = BruceLee.getActor(event.sourceEntity.id, BruceLee);
            if (bruceLee) {
                bruceLee.Properties.setProperty(key, value);
                // mclog(`Bruce Lee property ${key} set to ${value}`)
            }
        }
        catch (error) {
            mclog(`Error setting Bruce Lee property: ${error}`);
        }
    }
});
