import * as mc from "@minecraft/server";
import { mclog, non_solid_blocks, Vector3 } from "../utils/index";
const crystal_non_solid_blocks = [
    ...non_solid_blocks,
    "ldz_240913:dragon_crystal",
];
export class SnapToBlockFaceComponent {
    onPlace(event) {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m;
        mclog(`Checking block face for ${event.block.location}`, "SNAP_TO_BLOCK_FACE");
        if (!crystal_non_solid_blocks.includes((_b = (_a = event.block.below()) === null || _a === void 0 ? void 0 : _a.typeId) !== null && _b !== void 0 ? _b : "minecraft:air")) {
            event.block.setPermutation(mc.BlockPermutation.resolve(event.block.typeId, { "minecraft:block_face": "up" }));
        }
        else if (!crystal_non_solid_blocks.includes((_d = (_c = event.block.north()) === null || _c === void 0 ? void 0 : _c.typeId) !== null && _d !== void 0 ? _d : "minecraft:air")) {
            event.block.setPermutation(mc.BlockPermutation.resolve(event.block.typeId, { "minecraft:block_face": "south" }));
        }
        else if (!crystal_non_solid_blocks.includes((_f = (_e = event.block.south()) === null || _e === void 0 ? void 0 : _e.typeId) !== null && _f !== void 0 ? _f : "minecraft:air")) {
            event.block.setPermutation(mc.BlockPermutation.resolve(event.block.typeId, { "minecraft:block_face": "north" }));
        }
        else if (!crystal_non_solid_blocks.includes((_h = (_g = event.block.west()) === null || _g === void 0 ? void 0 : _g.typeId) !== null && _h !== void 0 ? _h : "minecraft:air")) {
            event.block.setPermutation(mc.BlockPermutation.resolve(event.block.typeId, { "minecraft:block_face": "east" }));
        }
        else if (!crystal_non_solid_blocks.includes((_k = (_j = event.block.east()) === null || _j === void 0 ? void 0 : _j.typeId) !== null && _k !== void 0 ? _k : "minecraft:air")) {
            event.block.setPermutation(mc.BlockPermutation.resolve(event.block.typeId, { "minecraft:block_face": "west" }));
        }
        else if (!crystal_non_solid_blocks.includes((_m = (_l = event.block.above()) === null || _l === void 0 ? void 0 : _l.typeId) !== null && _m !== void 0 ? _m : "minecraft:air")) {
            event.block.setPermutation(mc.BlockPermutation.resolve(event.block.typeId, { "minecraft:block_face": "below" }));
        }
        else {
            event.block.dimension.runCommand(`/setblock ${new Vector3(event.block.location)} minecraft:air [] destroy`);
        }
    }
    onTick(event) {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m;
        mclog(`Checking block face for ${event.block.location}`, "SNAP_TO_BLOCK_FACE");
        if (!crystal_non_solid_blocks.includes((_b = (_a = event.block.below()) === null || _a === void 0 ? void 0 : _a.typeId) !== null && _b !== void 0 ? _b : "minecraft:air")) {
            event.block.setPermutation(mc.BlockPermutation.resolve(event.block.typeId, { "minecraft:block_face": "up" }));
        }
        else if (!crystal_non_solid_blocks.includes((_d = (_c = event.block.north()) === null || _c === void 0 ? void 0 : _c.typeId) !== null && _d !== void 0 ? _d : "minecraft:air")) {
            event.block.setPermutation(mc.BlockPermutation.resolve(event.block.typeId, { "minecraft:block_face": "south" }));
        }
        else if (!crystal_non_solid_blocks.includes((_f = (_e = event.block.south()) === null || _e === void 0 ? void 0 : _e.typeId) !== null && _f !== void 0 ? _f : "minecraft:air")) {
            event.block.setPermutation(mc.BlockPermutation.resolve(event.block.typeId, { "minecraft:block_face": "north" }));
        }
        else if (!crystal_non_solid_blocks.includes((_h = (_g = event.block.west()) === null || _g === void 0 ? void 0 : _g.typeId) !== null && _h !== void 0 ? _h : "minecraft:air")) {
            event.block.setPermutation(mc.BlockPermutation.resolve(event.block.typeId, { "minecraft:block_face": "east" }));
        }
        else if (!crystal_non_solid_blocks.includes((_k = (_j = event.block.east()) === null || _j === void 0 ? void 0 : _j.typeId) !== null && _k !== void 0 ? _k : "minecraft:air")) {
            event.block.setPermutation(mc.BlockPermutation.resolve(event.block.typeId, { "minecraft:block_face": "west" }));
        }
        else if (!crystal_non_solid_blocks.includes((_m = (_l = event.block.above()) === null || _l === void 0 ? void 0 : _l.typeId) !== null && _m !== void 0 ? _m : "minecraft:air")) {
            event.block.setPermutation(mc.BlockPermutation.resolve(event.block.typeId, { "minecraft:block_face": "below" }));
        }
        else {
            event.block.dimension.runCommand(`/setblock ${new Vector3(event.block.location)} minecraft:air [] destroy`);
        }
    }
}
