import * as mc from "@minecraft/server";
import * as utils from "./utils/index";
export function initializeFirstLootDrop() {
    mc.world.afterEvents.entityDie.subscribe(event => {
        const attacker = event.damageSource.damagingEntity;
        const vitctim = event.deadEntity;
        if (attacker && attacker.typeId === 'minecraft:player' && vitctim.typeId === 'ldz_240913:opponent') {
            const player = new utils.SafetyCheckedPlayer(attacker);
            if (utils.readDynamicProperty(player, "ldz_240913:received_first_loot_drop"))
                return;
            utils.mclog('First loot drop spawned');
            player.runCommand("loot spawn ~ ~ ~ loot \"ldz/240913/first_loot_drop\"");
            utils.writeDynamicProperty(player, "ldz_240913:received_first_loot_drop", true);
        }
        ;
    });
}
