import * as mc from "@minecraft/server";
import * as utils from "./utils/index";
import { initializeFirstLootDrop } from "./first_loot_drop";
import { initializeOpponentSpawning } from "./opponents/spawning";
import { SnapToBlockFaceComponent } from "./dragon_crystals/SnapToBlockFace";
import { initializeScrollInteraction } from "./scrolls/quotes";
import { initializeScrollSpawning } from "./scrolls/spawning";
import { BackupSystem } from "./bruce_lee/backup";
import "./bruce_lee/bruce_lee";
import("./opponents/opponent");
import("./guide_book");
import("./achievements");
import("./outline");
mc.world.beforeEvents.worldInitialize.subscribe(event => {
    utils.mclog("Registering custom components");
    event.blockComponentRegistry.registerCustomComponent("ldz_240913:snap_to_block_face", new SnapToBlockFaceComponent());
});
/**
 * @remarks This is the entry point for the codebase
 */
async function main() {
    utils.GlobalNamespace.Namespace = "ldz_240913";
    utils.mclog("Hello World!");
    await utils.waitForWorldLoad();
    initializeFirstLootDrop();
    initializeOpponentSpawning();
    initializeScrollInteraction();
    initializeScrollSpawning();
    utils.setVersionNumber("v1.0.0");
}
mc.system.afterEvents.scriptEventReceive.subscribe((event) => {
    if (event.id === "ldz_240913:clear_backup") {
        BackupSystem.clearBackups();
    }
});
// Runs main on the next tick
mc.system.run(main);
