export const UNARMED_OPPONENT_ATTACKS = {
    attacks: [
        // Punch 1
        {
            damage: 2,
            cooldown: 0.5,
            range: 2,
            animation: "start_punch_1",
            duration: {
                damageTimes: [0.25],
                endTime: 0.75
            },
            soundEvent: "attack.punch_1"
        },
        // Punch 2
        {
            damage: 2,
            cooldown: 0.5,
            range: 2,
            animation: "start_punch_2",
            duration: {
                damageTimes: [0.29],
                endTime: 0.75
            },
            soundEvent: "attack.punch_2"
        },
        // Kick 1
        {
            damage: 2,
            cooldown: 0.5,
            range: 2,
            animation: "start_kick_1",
            duration: {
                damageTimes: [0.29],
                endTime: 0.7917
            },
            soundEvent: "attack.kick_1"
        },
        // Kick 2
        {
            damage: 2,
            cooldown: 0.5,
            range: 2,
            animation: "start_kick_2",
            duration: {
                damageTimes: [0.33],
                endTime: 0.6667
            },
            soundEvent: "attack.kick_2"
        }
    ]
};
export const SWORD_OPPONENT_ATTACKS = {
    attacks: [
        // Sword Slash 1
        {
            damage: 6,
            cooldown: 0.5,
            range: 2,
            animation: "start_sword",
            duration: {
                damageTimes: [0.33],
                endTime: 0.79
            },
            soundEvent: "attack.sword"
        },
        // Kick 1
        {
            damage: 2,
            cooldown: 0.5,
            range: 2,
            animation: "start_kick_1",
            duration: {
                damageTimes: [0.29],
                endTime: 0.7917
            },
            soundEvent: "attack.kick_1"
        },
        // Kick 2
        {
            damage: 2,
            cooldown: 0.5,
            range: 2,
            animation: "start_kick_2",
            duration: {
                damageTimes: [0.33],
                endTime: 0.6667
            },
            soundEvent: "attack.kick_2"
        }
    ]
};
export const KNIFE_OPPONENT_ATTACKS = {
    attacks: [
        // Knife Slash 1
        {
            damage: 6,
            cooldown: 0.5,
            range: 2,
            animation: "start_knife_1",
            duration: {
                damageTimes: [0.25],
                endTime: 0.79
            },
            soundEvent: "attack.knife_slash"
        },
        {
            damage: 6,
            cooldown: 0.5,
            range: 2,
            animation: "start_knife_2",
            duration: {
                damageTimes: [0.33],
                endTime: 0.79
            },
            soundEvent: "attack.knife_stab"
        },
        // Kick 1
        {
            damage: 2,
            cooldown: 0.5,
            range: 2,
            animation: "start_kick_1",
            duration: {
                damageTimes: [0.29],
                endTime: 0.7917
            },
            soundEvent: "attack.kick_1"
        },
        // Kick 2
        {
            damage: 2,
            cooldown: 0.5,
            range: 2,
            animation: "start_kick_2",
            duration: {
                damageTimes: [0.33],
                endTime: 0.6667
            },
            soundEvent: "attack.kick_2"
        }
    ]
};
export const DUAL_SWORDS_OPPONENT_ATTACKS = {
    attacks: [
        // Dual Sword Slash 1
        {
            damage: 6,
            cooldown: 0.5,
            range: 2,
            animation: "start_dual_sword_1",
            duration: {
                damageTimes: [0.4],
                endTime: 1.05
            },
            soundEvent: "attack.dual_sword"
        },
        {
            damage: 6,
            cooldown: 0.5,
            range: 2,
            animation: "start_dual_sword_2",
            duration: {
                damageTimes: [0.46, 0.54],
                endTime: 1.04
            },
            soundEvent: "attack.dual_sword"
        },
        // Kick 1
        {
            damage: 2,
            cooldown: 0.5,
            range: 2,
            animation: "start_kick_1",
            duration: {
                damageTimes: [0.29],
                endTime: 0.7917
            },
            soundEvent: "attack.kick_1"
        },
        // Kick 2
        {
            damage: 2,
            cooldown: 0.5,
            range: 2,
            animation: "start_kick_2",
            duration: {
                damageTimes: [0.33],
                endTime: 0.6667
            },
            soundEvent: "attack.kick_2"
        }
    ]
};
export const POLE_OPPONENT_ATTACKS = {
    attacks: [
        // Pole Slash 1
        {
            damage: 4,
            cooldown: 0.5,
            range: 2,
            animation: "start_pole_1",
            duration: {
                damageTimes: [0.42],
                endTime: 0.79
            },
            soundEvent: "attack.pole"
        },
        {
            damage: 4,
            cooldown: 0.2,
            range: 2,
            animation: "start_pole_2",
            duration: {
                damageTimes: [0.29],
                endTime: 0.79
            },
            soundEvent: "attack.pole_2"
        },
        // Kick 1
        {
            damage: 2,
            cooldown: 0.5,
            range: 2,
            animation: "start_kick_1",
            duration: {
                damageTimes: [0.29],
                endTime: 0.7917
            },
            soundEvent: "attack.kick_1"
        },
        // Kick 2
        {
            damage: 2,
            cooldown: 0.5,
            range: 2,
            animation: "start_kick_2",
            duration: {
                damageTimes: [0.33],
                endTime: 0.6667
            },
            soundEvent: "attack.kick_2"
        }
    ]
};
export const MOP_OPPONENT_ATTACKS = {
    attacks: [
        // Mop Slash 1
        {
            damage: 4,
            cooldown: 0.5,
            range: 2,
            animation: "start_pole_1",
            duration: {
                damageTimes: [0.42],
                endTime: 0.79
            }
        },
        {
            damage: 4,
            cooldown: 0.2,
            range: 2,
            animation: "start_pole_2",
            duration: {
                damageTimes: [0.29],
                endTime: 0.79
            }
        },
        // Kick 1
        {
            damage: 2,
            cooldown: 0.5,
            range: 2,
            animation: "start_kick_1",
            duration: {
                damageTimes: [0.29],
                endTime: 0.7917
            },
            soundEvent: "attack.kick_1"
        },
        // Kick 2
        {
            damage: 2,
            cooldown: 0.5,
            range: 2,
            animation: "start_kick_2",
            duration: {
                damageTimes: [0.33],
                endTime: 0.6667
            },
            soundEvent: "attack.kick_2"
        }
    ]
};
export const FRYING_PAN_OPPONENT_ATTACKS = {
    attacks: [
        // Frying Pan Slash 1
        {
            damage: 4,
            cooldown: 0.5,
            range: 2,
            animation: "start_frying_pan",
            duration: {
                damageTimes: [0.33],
                endTime: 0.79
            }
        },
        // Kick 1
        {
            damage: 2,
            cooldown: 0.5,
            range: 2,
            animation: "start_kick_1",
            duration: {
                damageTimes: [0.29],
                endTime: 0.7917
            },
            soundEvent: "attack.kick_1"
        },
        // Kick 2
        {
            damage: 2,
            cooldown: 0.5,
            range: 2,
            animation: "start_kick_2",
            duration: {
                damageTimes: [0.33],
                endTime: 0.6667
            },
            soundEvent: "attack.kick_2"
        }
    ]
};
