import * as utils from "../utils/index";
import { SoundPlayer } from "../actor_component/sound_player";
export const OPPONENT_SOUNDS = {
    "die": [
        "ldz_240913:opponent.die",
    ],
    "hurt": [
        "ldz_240913:opponent.hurt",
    ],
    "taunt": [
        "ldz_240913:opponent.taunt_2",
        "ldz_240913:opponent.taunt_3",
    ],
    "attack.dual_sword": [
        { 0.0: "ldz_240913:opponent.vocal_swing_5" }
    ],
    "attack.jump_both_sword": [
        { 0.05: "ldz_240913:opponent.vocal_swing_7" }
    ],
    "attack.kick_1": [
        { 0.0: "ldz_240913:opponent.vocal_swing_4" }
    ],
    "attack.kick_2": [
        { 0.0417: "ldz_240913:opponent.vocal_swing_2" }
    ],
    "attack.kick_3": [
        { 0.0: "ldz_240913:opponent.vocal_swing_3" }
    ],
    "attack.knife_slash": [
        { 0.0: "ldz_240913:opponent.vocal_swing_5" }
    ],
    "attack.knife_stab": [
        { 0.0: "ldz_240913:opponent.vocal_swing_7" }
    ],
    "attack.pole": [
        { 0.2083: "ldz_240913:opponent.vocal_swing_1" }
    ],
    "attack.pole_2": [
        { 0.0417: "ldz_240913:opponent.vocal_swing_2" }
    ],
    "attack.punch_1": [
        { 0.1667: "ldz_240913:opponent.vocal_swing_6" }
    ],
    "attack.punch_2": [
        { 0.0833: "ldz_240913:opponent.vocal_swing_5" }
    ],
    "attack.sword": [
        { 0.0: "ldz_240913:opponent.vocal_swing_4" }
    ],
};
export class OpponentSoundPlayer extends SoundPlayer {
    playSound(eventId, dimension, location) {
        super.playSound(eventId, dimension, location);
        // utils.getAllPlayersSafe().forEach(player => player.playSound())
    }
    stopSounds(eventId) {
        super.stopSounds(eventId);
    }
    playSoundToPlayers(soundReference, dimension, location) {
        utils.getAllPlayersSafe()
            .filter(player => player.dimension === dimension)
            .forEach(player => {
            var _a;
            const volume = ((_a = utils.readDynamicProperty(player, OpponentSoundPlayer.VOLUME_DYNAMIC_PROPERTY)) !== null && _a !== void 0 ? _a : 10) / 10;
            player.playSound(soundReference, { location, volume });
        });
    }
}
OpponentSoundPlayer.VOLUME_DYNAMIC_PROPERTY = "ldz_240913:volume.opponent";
