import { system, world } from "@minecraft/server";
import { getEntitiesSafe, readDynamicProperty, SafetyCheckedEntity, waitForTicks } from "../utils/index";
let lastSpawnedOpponentGroup = 0;
export function initializeOpponentSpawning() {
    world.afterEvents.entitySpawn.subscribe(async (event) => {
        var _a;
        if (event.entity.typeId === "ldz_240913:opponent_spawner" && (system.currentTick - lastSpawnedOpponentGroup > 40 * 60 || lastSpawnedOpponentGroup - system.currentTick > -60)) {
            let spawner = new SafetyCheckedEntity(event.entity);
            if (readDynamicProperty(world, "ldz_240913:opponents_during_day") === false) {
                await waitForTicks(1);
                let lightLevel = spawner.getProperty('ldz_240913:light_level');
                if (lightLevel > 8)
                    return;
            }
            let bruceLeeLevel = (_a = readDynamicProperty(world, "ldz_240913:highest_level_bruce_lee")) !== null && _a !== void 0 ? _a : 0;
            let bruceLees = getEntitiesSafe(spawner.dimension, { type: "ldz_240913:bruce_lee", maxDistance: 256, location: spawner.location }).length - 1;
            let maxOpponents = 5;
            maxOpponents += Math.floor((bruceLeeLevel / 10) * 1.5);
            maxOpponents += bruceLees * 2;
            let nearbyOpponents = getEntitiesSafe(spawner.dimension, { location: spawner.location, maxDistance: 256, type: "ldz_240913:opponent" });
            if (nearbyOpponents.length > maxOpponents)
                return;
            let opponentAmount = Math.floor(Math.random() * 2 + 1);
            for (let i = 0; i < opponentAmount; i++) {
                let location = spawner.location;
                let opp = spawner.dimension.spawnEntity("ldz_240913:opponent", location);
                opp.triggerEvent("choose_targeting");
            }
            lastSpawnedOpponentGroup = system.currentTick;
        }
    });
}
