import * as mc from "@minecraft/server";
import * as utils from "../utils/index";
export function initializeScrollSpawning() {
    utils.getAllPlayersSafe().forEach(player => { startSpawningClock(player); });
    mc.world.afterEvents.playerSpawn.subscribe(event => {
        if (event.initialSpawn) {
            startSpawningClock(new utils.SafetyCheckedPlayer(event.player));
        }
    });
}
function startSpawningClock(player) {
    utils.abortEvents(`SpawningClock${player.id}`);
    utils.waitForLoopEvent(1200, () => {
        utils.mclog("Attempting to spawn a scroll");
        let rand = utils.getRandomInteger(0, 1);
        if (rand === 0)
            rand = -1;
        player.runCommand(`execute positioned ^${16 * rand} ^ ^60 positioned ~ 128 ~ run summon ldz_240913:scroll ~ ~ ~ 0 0 spawned_naturally`);
    }, `SpawningClock${player.id}`, false);
}
